# Your first transaction with PayPal

This tutorial presents the steps required to do your first transaction through the PayPal eComm API with Verifone. At the end of the tutorial, you will have basic understanding of how the PayPal eComm API works and how to perform transactions.

## Setting up <a href="#step-1__003a-set-up" id="step-1__003a-set-up"></a>

Before making a transaction, you need:

* A PayPal Sandbox account.
* To obtain an [API key](/online-payments/api-integration-methods-auth-and-endpoints/api-authentication.md).
* The Payment Provider Contract ID associated to your PayPal connection as part of your onboarding into [Verifone Central](https://docs.verifone.com/verifone-central-getting-started/).

Read more about the [managed path or connected path integration](https://developer.paypal.com/limited-release/commerce-platform/) available with PayPal.

## Creating a transaction <a href="#step-2__003a-tokenizing-a-card" id="step-2__003a-tokenizing-a-card"></a>

Make a POST request to /transactions endpoint. Here is an example of a payload:

```http
POST /transactions
```

Payload:

```json
{
    "intent": "AUTHORIZE",
    "paymentProviderContract": "YOUR_PAYMENT_PROVIDER_CONTRACT",
    "amount": {
    	"value": 2700,
    	"currencyCode": "USD"
    },  
    "customer": {
        "email": "yourEmail@personal.example.com",
        "payerId": "WDJJHEBZ4X2LY",
        "phoneNumber": {
            "phoneType": "MOBILE",
            "value": "64646464"
        },
        "birthDate": "2000-01-31",
            "identification": {
            "taxIdentificationNumber": "123456",
            "taxIdentificationType": "BR_CNPJ"
        },
        "address": {
            "country": "IN",
            "postalCode": "570023",
            "countrySubdivision": "IN-MH",
            "city": "yyy",
            "addressLine1": "add1",
            "addressLine2": "add2"
        },
        "firstName": "James",
        "lastName": "Smith"
    },
    "applicationContext": {
        "brandName": "MAHENDRA",
        "locale": "he-IL",
        "landingPage": "BILLING",
        "returnUrl": "http://example.com/success",
        "cancelUrl": "http://example.com/failure"
    },
    "shipping": {
        "address": {
            "country": "IN",
            "postalCode": "91",
            "countrySubdivision": "IN-MH",
            "city": "mysore",
            "addressLine1": "walstreet",
            "addressLine2": "forcircle"
        },
        "fullName": "JamesSmith"
    },
    "items": [
        {
            "name": "Mac Laptop",
            "unitAmount": {
                "currencyCode": "USD",
                "value": 100
            },
            "tax": {
                "currencyCode": "USD",
                "value": 100
            },
            "quantity": "1",
            "description": "Dell Laptop",
            "sku": "123",
            "category": "PHYSICAL_GOODS"
        },
        {
            "name": "Phone",
            "unitAmount": {
                "currencyCode": "USD",
                "value": 100
            },
            "tax": {
                "currencyCode": "USD",
                "value": 100
            },
            "quantity": "10",
            "description": "Apple phone",
            "sku": "456",
            "category": "PHYSICAL_GOODS"
        },
        {
            "name": "Dell XPS 9310 13.4 FHD Display Thin & Light 11th Gen Laptop (i5-1135G7 / 8 GB / 512 SSD / Integrated Graphics / 1Yr Premium",
            "unitAmount": {
                "currencyCode": "USD",
                "value": 100
            },
            "tax": {
                "currencyCode": "USD",
                "value": 100
            },
            "quantity": "1",
            "description": "groceries",
            "sku": "456",
            "category": "PHYSICAL_GOODS"
        },
        {
            "name": "Samsung 6.5 kg Fully-Automatic Top Loading Washing Machine (WA65A4002VS/TL, Imperial Silver, Center Jet Technology)",
            "unitAmount": {
                "currencyCode": "USD",
                "value": 100
            },
            "tax": {
                "currencyCode": "USD",
                "value": 100
            },
            "quantity": "1",
            "description": "product",
            "sku": "456",
            "category": "PHYSICAL_GOODS"
        }
    ],
    "dynamicDescriptor": "Paypal order DD123",
    "merchantReference": "DD123-reference",
    "detailedAmount": {
        "discount": {
            "currencyCode": "USD",
            "value": 100
        },
        "shippingDiscount": {
            "currencyCode": "USD",
            "value": 100
        },
        "insurance": {
            "currencyCode": "USD",
            "value": 100
        },  
        "handling": {
            "currencyCode": "USD",
            "value": 100
        },
        "shipping": {
            "currencyCode": "USD",
            "value": 100
        }
    }
}
```

Response example:

```json
{
   "id": "27241ae8-e72a-4586-9ef2-78dcb7a0ad9f",
   "orderId": "4DD655383X489915V",
   "createdAt": "2021-02-04T17:23:44Z",
   "status": "INITIATED",
   "approvalUrl": "https://www.sandbox.paypal.com/checkoutnow?token=4DD655383X489915V"
}
```

For details about the API and the request fields, review the [Create Transaction API](/api-reference/open-api-references/ecommerce.md).

## Approving the transaction <a href="#approving-the-transaction" id="approving-the-transaction"></a>

Open the approvalUrl link from the previous API response in the browser, to approve the transaction. This would open the PayPal portal and would show the login page. Login using your PayPal buyer credentials and, after reviewing the transaction detail, approve the transaction. After the approval, you would be redirected to the returnUrl that was passed in the applicationContext while creating the transaction. Also, if you cancel the approval flow in between, then you would be redirected to the cancelUrl.

## Authorizing the transaction <a href="#authorizing-the-transaction" id="authorizing-the-transaction"></a>

Make a POST request to /transactions/:id/authorize for authorizing a transaction.

```http
POST /transactions/:id/authorize
```

{% hint style="info" %}
This step is only required if the intent is to authorize a transaction. If the intent is to capture a transaction, skip this step.
{% endhint %}

The ID parameter in the URL is the ID from the response of the create transaction API call.

## Capture a payment <a href="#capture-a-payment" id="capture-a-payment"></a>

Make a POST request to /transactions/:id/capture to capture a transaction payment. Use ID field from step 2 as request parameter.

```http
POST /transactions/:id/capture
```

If you want to capture the full transaction, then there is no need to send the amount in the request payload, instead a *null* in the request body is to be sent.

However, if you want to capture a partial amount of the transaction, then you can send the amount object in the request payload as shown below:

```json
 {
   "amount": {
       "value": 50,
       "currencyCode": "USD"
   }
}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.verifone.com/online-payments/advanced-payment-methods-apms/paypal/your-first-transaction-with-paypal.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
